float screenspace_contact_shadow(materials m, vec3 view_position, vec3 position, vec3 direction){
    shadow_settings s = pshadow();

    #ifdef TAA
        float noise = blue_noise(gl_FragCoord.xy).w;
    #else
        float noise = 0.0;
    #endif

    if(m.leaves || m.textured){
        s.strength = 0.0;
    }


    #if defined DEFERRED6
        if(m.grass){
            s.strength = 0.6;
            s.z_depth = 0.08;
        }
    #endif

    direction = abs(-position.z) * direction;
    direction = normalize(view_to_screenspace(direction + position) - view_position);

    vec3 s_increment = direction * (s.z_depth / s.steps1);
    vec3 s_position = view_position + s_increment * (noise + 1);

    float depth = texture2(depthtex1, s_position.xy).x;

    float shadow = 1;

    #ifdef SCREEN_SPACE_SHADOW
        for(int i = 0; i < s.steps1; i++, s_position += s_increment){
            if(saturate(s_position) != s_position) break;

            depth = texture2(depthtex1, s_position.xy).x;

            if(depth < s_position.z){
                float depth0 = linear_depth(s_position.z);
                float depth1 = linear_depth(depth);

                float dist = abs(depth1 - depth0) / depth1;

                if(dist < s.z_depth && depth0 > -far){
                    shadow *= 1.0 - s.strength;
                }
            }
        }
    #endif
        
    return shadow;   
}