vec2 pcss(shadow_settings s, vec3 position, float bias, float noise){
     atmosphere_constant ac = atmosphere();

     float angle = (sunAngle < 0.5 ? ac.sun_angular_radius : ac.moon_angular_radius) * 16.0;
     float max_spread = s.inverse_resolution * 12.0;

     vec2 blocker_depth = vec2(0.0);

     for(int i = 0; i < s.steps0; i++){
          vec2 offset = sample_disk(i, noise, s.steps0);

          vec3 shadow_position = vec3(offset, -bias) * max_spread + position;
               shadow_position = shadow_distortion(s, shadow_position) * 0.5 + 0.5;
               shadow_position -= bias;

          float depth0 = texture2(shadowtex0, shadow_position.xy).x;
          float depth1 = texture2(shadowtex1, shadow_position.xy).x;

          blocker_depth.x = max(blocker_depth.x, shadow_position.z - depth0);
          blocker_depth.y = max(blocker_depth.y, shadow_position.z - depth1);
     }

     return min(blocker_depth * angle, vec2(max_spread));
}