#if defined SHADERS_VERTEX
    out vec2 coord;

    void main(){
        coord = layout_texcoord.xy;

        gl_Position = vec4(coord * 2.0 - 1.0, 0.0, 1.0);
    }
#elif defined SHADERS_FRAGMENT
    in vec2 coord;

    #include "/program/shaders1/common/indirect/filter.glsl"

    void main(){
        gbuffers_data g = gbuffers(coord);
        space_position sp = position(coord, g.depth, false);
        materials m = material(g.depth, g.ID);

        #if defined DEFERRED4
            const float s = 1.0;
        #elif defined DEFERRED5
            const float s = 2.0;
        #endif  

        buffers0.xyz = rsm_filter(coord, s);
        buffers0.w = texture2(colortex10, coord).w;

        buffers1.xyz = texture2(colortex11, coord).xyz;
        buffers1.w = ao_filter(coord, s);

        /* RENDERTARGETS:10,11 */
    }
#endif